import .connectives
import .leibniz
import .logic
axiom nat.nat : Type.
constant nat.O : nat.nat.
constant nat.S : (nat.nat) -> nat.nat.
constant nat.filter_nat_type : forall (return : Type) , ((nat.nat) -> return) -> (nat.nat) -> return.
axiom nat.axiom_filter_nat_type_O : forall (return_type : Type) , forall (return:(nat.nat) -> return_type) , (((connectives.equal) (return_type)) ((((nat.filter_nat_type) (return_type)) (return)) ((nat.O) ))) ((return) ((nat.O) )).
theorem nat.eq_filter_nat_type_O : forall (return_type : Type) , forall (return:(nat.nat) -> return_type) , (((leibniz.leibniz) (return_type)) ((((nat.filter_nat_type) (return_type)) (return)) ((nat.O) ))) ((return) ((nat.O) )) := fun (return_type : Type) , fun (return : (nat.nat) -> return_type) , ((((@connectives.equal_leibniz) (return_type)) ((((nat.filter_nat_type) (return_type)) (return)) ((nat.O) ))) ((return) ((nat.O) ))) (((@nat.axiom_filter_nat_type_O) (return_type)) (return)).
theorem nat.sym_eq_filter_nat_type_O : forall (return_type : Type) , forall (return:(nat.nat) -> return_type) , (((leibniz.leibniz) (return_type)) ((return) ((nat.O) ))) ((((nat.filter_nat_type) (return_type)) (return)) ((nat.O) )) := fun (return_type : Type) , fun (return : (nat.nat) -> return_type) , ((((@leibniz.sym_leibniz) (return_type)) ((((nat.filter_nat_type) (return_type)) (return)) ((nat.O) ))) ((return) ((nat.O) ))) (((@nat.eq_filter_nat_type_O) (return_type)) (return)).
axiom nat.axiom_filter_nat_type_S : forall (return_type : Type) , forall (return:(nat.nat) -> return_type) , forall (n:nat.nat) , (((connectives.equal) (return_type)) ((((nat.filter_nat_type) (return_type)) (return)) (((nat.S) ) (n)))) ((return) (((nat.S) ) (n))).
theorem nat.eq_filter_nat_type_S : forall (return_type : Type) , forall (return:(nat.nat) -> return_type) , forall (n:nat.nat) , (((leibniz.leibniz) (return_type)) ((((nat.filter_nat_type) (return_type)) (return)) (((nat.S) ) (n)))) ((return) (((nat.S) ) (n))) := fun (return_type : Type) , fun (return : (nat.nat) -> return_type) , fun (n : nat.nat) , ((((@connectives.equal_leibniz) (return_type)) ((((nat.filter_nat_type) (return_type)) (return)) (((nat.S) ) (n)))) ((return) (((nat.S) ) (n)))) ((((@nat.axiom_filter_nat_type_S) (return_type)) (return)) (n)).
theorem nat.sym_eq_filter_nat_type_S : forall (return_type : Type) , forall (return:(nat.nat) -> return_type) , forall (n:nat.nat) , (((leibniz.leibniz) (return_type)) ((return) (((nat.S) ) (n)))) ((((nat.filter_nat_type) (return_type)) (return)) (((nat.S) ) (n))) := fun (return_type : Type) , fun (return : (nat.nat) -> return_type) , fun (n : nat.nat) , ((((@leibniz.sym_leibniz) (return_type)) ((((nat.filter_nat_type) (return_type)) (return)) (((nat.S) ) (n)))) ((return) (((nat.S) ) (n)))) ((((@nat.eq_filter_nat_type_S) (return_type)) (return)) (n)).
axiom nat.nat_ind : forall (Q:(nat.nat) -> Prop) , ((Q) ((nat.O) )) -> (forall (x:nat.nat) , ((Q) (x)) -> (Q) (((nat.S) ) (x))) -> forall (x:nat.nat) , (Q) (x).
constant nat.plus : (nat.nat) -> (nat.nat) -> nat.nat.
constant nat.plus_body : (nat.nat) -> (nat.nat) -> nat.nat.
axiom nat.axiom_plus : forall (n:nat.nat) , (((connectives.equal) ((nat.nat) -> nat.nat)) (((nat.plus) ) (n))) ((((nat.filter_nat_type) ((nat.nat) -> nat.nat)) ((nat.plus_body) )) (n)).
theorem nat.eq_plus : forall (n:nat.nat) , (((leibniz.leibniz) ((nat.nat) -> nat.nat)) (((nat.plus) ) (n))) ((((nat.filter_nat_type) ((nat.nat) -> nat.nat)) ((nat.plus_body) )) (n)) := fun (n : nat.nat) , ((((@connectives.equal_leibniz) ((nat.nat) -> nat.nat)) (((nat.plus) ) (n))) ((((nat.filter_nat_type) ((nat.nat) -> nat.nat)) ((nat.plus_body) )) (n))) ((@nat.axiom_plus) (n)).
theorem nat.sym_eq_plus : forall (n:nat.nat) , (((leibniz.leibniz) ((nat.nat) -> nat.nat)) ((((nat.filter_nat_type) ((nat.nat) -> nat.nat)) ((nat.plus_body) )) (n))) (((nat.plus) ) (n)) := fun (n : nat.nat) , ((((@leibniz.sym_leibniz) ((nat.nat) -> nat.nat)) (((nat.plus) ) (n))) ((((nat.filter_nat_type) ((nat.nat) -> nat.nat)) ((nat.plus_body) )) (n))) ((@nat.eq_plus) (n)).
axiom nat.axiom_plus_body_O : (((connectives.equal) ((nat.nat) -> nat.nat)) (((nat.plus_body) ) ((nat.O) ))) (fun (m : nat.nat) , m).
theorem nat.eq_plus_body_O : (((leibniz.leibniz) ((nat.nat) -> nat.nat)) (((nat.plus_body) ) ((nat.O) ))) (fun (m : nat.nat) , m) := ((((@connectives.equal_leibniz) ((nat.nat) -> nat.nat)) (((nat.plus_body) ) ((nat.O) ))) (fun (m : nat.nat) , m)) (@nat.axiom_plus_body_O).
theorem nat.sym_eq_plus_body_O : (((leibniz.leibniz) ((nat.nat) -> nat.nat)) (fun (m : nat.nat) , m)) (((nat.plus_body) ) ((nat.O) )) := ((((@leibniz.sym_leibniz) ((nat.nat) -> nat.nat)) (((nat.plus_body) ) ((nat.O) ))) (fun (m : nat.nat) , m)) (@nat.eq_plus_body_O).
constant nat.times : (nat.nat) -> (nat.nat) -> nat.nat.
constant nat.times_body : (nat.nat) -> (nat.nat) -> nat.nat.
axiom nat.axiom_times : forall (n:nat.nat) , (((connectives.equal) ((nat.nat) -> nat.nat)) (((nat.times) ) (n))) ((((nat.filter_nat_type) ((nat.nat) -> nat.nat)) ((nat.times_body) )) (n)).
theorem nat.eq_times : forall (n:nat.nat) , (((leibniz.leibniz) ((nat.nat) -> nat.nat)) (((nat.times) ) (n))) ((((nat.filter_nat_type) ((nat.nat) -> nat.nat)) ((nat.times_body) )) (n)) := fun (n : nat.nat) , ((((@connectives.equal_leibniz) ((nat.nat) -> nat.nat)) (((nat.times) ) (n))) ((((nat.filter_nat_type) ((nat.nat) -> nat.nat)) ((nat.times_body) )) (n))) ((@nat.axiom_times) (n)).
theorem nat.sym_eq_times : forall (n:nat.nat) , (((leibniz.leibniz) ((nat.nat) -> nat.nat)) ((((nat.filter_nat_type) ((nat.nat) -> nat.nat)) ((nat.times_body) )) (n))) (((nat.times) ) (n)) := fun (n : nat.nat) , ((((@leibniz.sym_leibniz) ((nat.nat) -> nat.nat)) (((nat.times) ) (n))) ((((nat.filter_nat_type) ((nat.nat) -> nat.nat)) ((nat.times_body) )) (n))) ((@nat.eq_times) (n)).
axiom nat.axiom_times_body_O : (((connectives.equal) ((nat.nat) -> nat.nat)) (((nat.times_body) ) ((nat.O) ))) (fun (m : nat.nat) , (nat.O) ).
theorem nat.eq_times_body_O : (((leibniz.leibniz) ((nat.nat) -> nat.nat)) (((nat.times_body) ) ((nat.O) ))) (fun (m : nat.nat) , (nat.O) ) := ((((@connectives.equal_leibniz) ((nat.nat) -> nat.nat)) (((nat.times_body) ) ((nat.O) ))) (fun (m : nat.nat) , (nat.O) )) (@nat.axiom_times_body_O).
theorem nat.sym_eq_times_body_O : (((leibniz.leibniz) ((nat.nat) -> nat.nat)) (fun (m : nat.nat) , (nat.O) )) (((nat.times_body) ) ((nat.O) )) := ((((@leibniz.sym_leibniz) ((nat.nat) -> nat.nat)) (((nat.times_body) ) ((nat.O) ))) (fun (m : nat.nat) , (nat.O) )) (@nat.eq_times_body_O).
axiom nat.axiom_times_body_S : forall (n:nat.nat) , (((connectives.equal) ((nat.nat) -> nat.nat)) (((nat.times_body) ) (((nat.S) ) (n)))) (fun (m : nat.nat) , (((nat.plus) ) (m)) ((((nat.times) ) (n)) (m))).
theorem nat.eq_times_body_S : forall (n:nat.nat) , (((leibniz.leibniz) ((nat.nat) -> nat.nat)) (((nat.times_body) ) (((nat.S) ) (n)))) (fun (m : nat.nat) , (((nat.plus) ) (m)) ((((nat.times) ) (n)) (m))) := fun (n : nat.nat) , ((((@connectives.equal_leibniz) ((nat.nat) -> nat.nat)) (((nat.times_body) ) (((nat.S) ) (n)))) (fun (m : nat.nat) , (((nat.plus) ) (m)) ((((nat.times) ) (n)) (m)))) ((@nat.axiom_times_body_S) (n)).
theorem nat.sym_eq_times_body_S : forall (n:nat.nat) , (((leibniz.leibniz) ((nat.nat) -> nat.nat)) (fun (m : nat.nat) , (((nat.plus) ) (m)) ((((nat.times) ) (n)) (m)))) (((nat.times_body) ) (((nat.S) ) (n))) := fun (n : nat.nat) , ((((@leibniz.sym_leibniz) ((nat.nat) -> nat.nat)) (((nat.times_body) ) (((nat.S) ) (n)))) (fun (m : nat.nat) , (((nat.plus) ) (m)) ((((nat.times) ) (n)) (m)))) ((@nat.eq_times_body_S) (n)).
theorem nat.plus_O_n : forall (n:nat.nat) , (((logic.eq_) (nat.nat)) (n)) ((((nat.plus) ) ((nat.O) )) (n)) := fun (n : nat.nat) , (((@nat.sym_eq_plus) ((nat.O) )) (fun (y : (nat.nat) -> nat.nat) , (((logic.eq_) (nat.nat)) (n)) ((y) (n)))) (((((@nat.sym_eq_filter_nat_type_O) ((nat.nat) -> nat.nat)) ((nat.plus_body) )) (fun (y : (nat.nat) -> nat.nat) , (((logic.eq_) (nat.nat)) (n)) ((y) (n)))) (((@nat.sym_eq_plus_body_O) (fun (y : (nat.nat) -> nat.nat) , (((logic.eq_) (nat.nat)) (n)) ((y) (n)))) (((@logic.refl_) (nat.nat)) (n)))).
theorem nat.times_Sn_m : forall (n:nat.nat) , forall (m:nat.nat) , (((logic.eq_) (nat.nat)) ((((nat.plus) ) (m)) ((((nat.times) ) (n)) (m)))) ((((nat.times) ) (((nat.S) ) (n))) (m)) := fun (n : nat.nat) , fun (m : nat.nat) , (((@nat.sym_eq_times) (((nat.S) ) (n))) (fun (y : (nat.nat) -> nat.nat) , (((logic.eq_) (nat.nat)) ((((nat.plus) ) (m)) ((((nat.times) ) (n)) (m)))) ((y) (m)))) ((((((@nat.sym_eq_filter_nat_type_S) ((nat.nat) -> nat.nat)) ((nat.times_body) )) (n)) (fun (y : (nat.nat) -> nat.nat) , (((logic.eq_) (nat.nat)) ((((nat.plus) ) (m)) ((((nat.times) ) (n)) (m)))) ((y) (m)))) ((((@nat.sym_eq_times_body_S) (n)) (fun (y : (nat.nat) -> nat.nat) , (((logic.eq_) (nat.nat)) ((((nat.plus) ) (m)) ((((nat.times) ) (n)) (m)))) ((y) (m)))) (((@logic.refl_) (nat.nat)) ((((nat.plus) ) (m)) ((((nat.times) ) (n)) (m)))))).
theorem nat.times_O_n : forall (n:nat.nat) , (((logic.eq_) (nat.nat)) ((nat.O) )) ((((nat.times) ) ((nat.O) )) (n)) := fun (n : nat.nat) , (((@nat.sym_eq_times) ((nat.O) )) (fun (y : (nat.nat) -> nat.nat) , (((logic.eq_) (nat.nat)) ((nat.O) )) ((y) (n)))) (((((@nat.sym_eq_filter_nat_type_O) ((nat.nat) -> nat.nat)) ((nat.times_body) )) (fun (y : (nat.nat) -> nat.nat) , (((logic.eq_) (nat.nat)) ((nat.O) )) ((y) (n)))) (((@nat.sym_eq_times_body_O) (fun (y : (nat.nat) -> nat.nat) , (((logic.eq_) (nat.nat)) ((nat.O) )) ((y) (n)))) (((@logic.refl_) (nat.nat)) ((nat.O) )))).
theorem nat.times_n_O : forall (n:nat.nat) , (((logic.eq_) (nat.nat)) ((nat.O) )) ((((nat.times) ) (n)) ((nat.O) )) := fun (n : nat.nat) , ((((@nat.nat_ind) (fun (_x_365 : nat.nat) , (((logic.eq_) (nat.nat)) ((nat.O) )) ((((nat.times) ) (_x_365)) ((nat.O) )))) (((((((@logic.rewrite_l) (nat.nat)) ((nat.O) )) (fun (__ : nat.nat) , (((logic.eq_) (nat.nat)) ((nat.O) )) (__))) (((@logic.refl_) (nat.nat)) ((nat.O) ))) ((((nat.times) ) ((nat.O) )) ((nat.O) ))) ((@nat.times_O_n) ((nat.O) )))) (fun (x_366 : nat.nat) , fun (_x_368 : (((logic.eq_) (nat.nat)) ((nat.O) )) ((((nat.times) ) (x_366)) ((nat.O) ))) , (((((((@logic.rewrite_l) (nat.nat)) ((((nat.plus) ) ((nat.O) )) ((((nat.times) ) (x_366)) ((nat.O) )))) (fun (__ : nat.nat) , (((logic.eq_) (nat.nat)) ((nat.O) )) (__))) (((((((@logic.rewrite_l) (nat.nat)) ((nat.O) )) (fun (__ : nat.nat) , (((logic.eq_) (nat.nat)) ((nat.O) )) ((((nat.plus) ) ((nat.O) )) (__)))) (((((((@logic.rewrite_l) (nat.nat)) ((nat.O) )) (fun (__ : nat.nat) , (((logic.eq_) (nat.nat)) ((nat.O) )) (__))) (((@logic.refl_) (nat.nat)) ((nat.O) ))) ((((nat.plus) ) ((nat.O) )) ((nat.O) ))) ((@nat.plus_O_n) ((nat.O) )))) ((((nat.times) ) (x_366)) ((nat.O) ))) (_x_368))) ((((nat.times) ) (((nat.S) ) (x_366))) ((nat.O) ))) (((@nat.times_Sn_m) (x_366)) ((nat.O) ))))) (n).
